"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAdministratorMiddleware = void 0;
const cors_1 = __importDefault(require("cors"));
const express_1 = __importStar(require("express"));
const config_1 = require("./config/config");
const flashcard_router_1 = require("./routers/flashcard.router");
// import {userRouter} from "./routers/user.router";
const mongoose_1 = __importDefault(require("mongoose"));
const passport_1 = __importDefault(require("passport"));
const passport_local_1 = __importDefault(require("passport-local"));
const cookie_parser_1 = __importDefault(require("cookie-parser"));
const express_session_1 = __importDefault(require("express-session"));
const bcryptjs_1 = __importDefault(require("bcryptjs"));
const User_1 = __importDefault(require("./utils/User"));
const dotenv_1 = __importDefault(require("dotenv"));
const express_rate_limit_1 = __importDefault(require("express-rate-limit"));
const LocalStrategy = passport_local_1.default.Strategy;
dotenv_1.default.config();
mongoose_1.default.connect(`${process.env.PART1STRING}${process.env.MYUSERNAME}:${process.env.PASSWORD}${process.env.PART2STRING}`, (err) => {
    if (err)
        throw err;
    console.log("Connected to Mongo");
});
const app = (0, express_1.default)();
app.use(express_1.default.json());
app.use((0, cors_1.default)({ origin: config_1.config.corsOrigin, credentials: true }));
app.use((0, express_session_1.default)({
    secret: "secretcode",
    resave: true,
    saveUninitialized: true,
}));
app.use((0, cookie_parser_1.default)());
app.use(passport_1.default.initialize());
app.use(passport_1.default.session());
passport_1.default.use(new LocalStrategy((username, password, done) => {
    User_1.default.findOne({ username: username }, (err, user) => {
        if (err)
            throw err;
        if (!user)
            return done(null, false);
        bcryptjs_1.default.compare(password, user.password, (err, result) => {
            if (err)
                throw err;
            if (result) {
                return done(null, user);
            }
            else {
                return done(null, false);
            }
        });
    });
}));
app.use((0, express_1.json)());
app.use((0, express_rate_limit_1.default)({
    windowMs: 5 * 60 * 100,
    max: 500,
}));
passport_1.default.serializeUser((user, cb) => {
    cb(null, user._id);
});
passport_1.default.deserializeUser((id, cb) => {
    User_1.default.findOne({ _id: id }, (err, user) => {
        const userInformation = {
            username: user.username,
            isAdmin: user.isAdmin,
            id: user._id
        };
        cb(err, userInformation);
    });
});
const router = (0, express_1.Router)();
router.use('/flashcard/', flashcard_router_1.flashcardRouter);
app.use('/api/', router);
router.post('/register', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const { username, password } = req === null || req === void 0 ? void 0 : req.body;
    if (!username || !password || typeof username !== "string" || typeof password !== "string") {
        res.send("Improper Values");
        return;
    }
    User_1.default.findOne({ username }, (err, doc) => __awaiter(void 0, void 0, void 0, function* () {
        if (err)
            throw err;
        if (doc)
            res.send("User Already Exists");
        if (!doc) {
            const hashedPassword = yield bcryptjs_1.default.hash(password, 10);
            const newUser = new User_1.default({
                username,
                password: hashedPassword,
            });
            yield newUser.save();
            res.send("success");
        }
    }));
}));
const isAdministratorMiddleware = (req, res, next) => {
    const { user } = req;
    if (user) {
        User_1.default.findOne({ username: user.username }, (err, doc) => {
            if (err)
                throw err;
            if (doc === null || doc === void 0 ? void 0 : doc.isAdmin) {
                next();
            }
            else {
                res.send("Sorry, only admin's can perform this.");
            }
        });
    }
    else {
        res.send("Sorry, you are logged in.");
    }
};
exports.isAdministratorMiddleware = isAdministratorMiddleware;
router.post("/login", passport_1.default.authenticate("local"), (req, res) => {
    res.send('success');
});
router.get('/user', (req, res) => {
    res.send(req.user);
});
router.get('/logout', (req, res) => {
    req.logout(function () {
        console.log('Done logging out.');
    });
    res.send('success');
});
router.get('/getallusers', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    User_1.default.find({}, (err, data) => {
        if (err)
            throw err;
        const filteredUsers = [];
        data.forEach((item) => {
            const userInformation = {
                id: item._id,
                username: item.username,
                isAdmin: item.isAdmin
            };
            filteredUsers.push(userInformation);
        });
        res.send(filteredUsers);
    });
}));
app.listen(3001, 0.0, .0, .0, () => {
    console.log('Listening on 0.0.0.0:3001');
});
//# sourceMappingURL=index.js.map