"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserRecord = void 0;
const db_1 = require("../utils/db");
const { v4: uuid } = require('uuid');
class UserRecord {
    constructor(obj) {
        this.id = obj.id;
        this.name = obj.name;
        this.email = obj.email;
        this.hashedPassword = obj.hashedPassword;
    }
    static addFlashcard(name, email, hashedPassword) {
        return __awaiter(this, void 0, void 0, function* () {
            yield db_1.pool.execute("INSERT INTO `users` VALUES (:id, :name, :email, :hashedPassword);", {
                id: uuid(),
                name: name,
                email: email,
                hashedPassword: hashedPassword,
            });
        });
    }
    static getOneForId(id) {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield db_1.pool.execute("SELECT * FROM `users` WHERE `id`=:id", {
                id: id,
            });
            return result;
        });
    }
    static getOneForEmail(email) {
        return __awaiter(this, void 0, void 0, function* () {
            const [result] = yield db_1.pool.execute("SELECT * FROM `users` WHERE `email`=:email", {
                email: email,
            });
            return result;
        });
    }
}
exports.UserRecord = UserRecord;
//# sourceMappingURL=user.record.js.map