"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.flashcardRouter = void 0;
const express_1 = require("express");
const flashcard_record_1 = require("../records/flashcard.record");
exports.flashcardRouter = (0, express_1.Router)()
    .get('/list', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const { user } = req;
    const userObj = JSON.stringify(user);
    const ar = [];
    for (let key in user) {
        ar.push(user[key]);
    }
    const userId = userObj ? (ar[2]).toString() : null;
    const data = yield flashcard_record_1.FlashcardRecord.findAllForUser(userId);
    res.json(data);
}))
    .get('/one', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const { user } = req;
    const userObj = JSON.stringify(user);
    const ar = [];
    for (let key in user) {
        ar.push(user[key]);
    }
    const userId = userObj ? (ar[2]).toString() : null;
    const data = yield flashcard_record_1.FlashcardRecord.findOneRandomForUser(userId);
    res.json(data);
}))
    .post('/add', (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    if (req.body) {
        const { front, back, category, userId } = req.body;
        const result = yield flashcard_record_1.FlashcardRecord.findOneForUserByFront(userId, front);
        if (result === null) {
            yield flashcard_record_1.FlashcardRecord.addFlashcard(front, back, category, userId);
            res.json('success');
        }
        else {
            res.json('The same flashcard already exist');
        }
    }
}));
// .get('/:id', async (req, res) => {
//
//     const oneFlashcard = await FlashcardRecord.getOneForUser("58b03369-ed61-11ec-a0e7-1c666d8b4151", req.params.id);
//     console.log(oneFlashcard)
//     res.json(oneFlashcard)
// })
//
//
//     .delete('/:id', async (req, res) => {
//
//         console.log(req.params.id);
//         await FlashcardRecord.removeFlashcard(req.params.id);
//
//     })
// ;
//# sourceMappingURL=flashcard.router.js.map